VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsButtons"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' This Class is a simulate of the Buttons Collections


' A Counter of how many buttons are in the collection
Private mvar_Count As Integer

Private colButtons As New Collection

Public Enum ezButtonStyle
    ezDefault = 0
    ezCheck
    ezButtonGroup
    ezSeparator
    ezPlaceholder
    ezComboBox
End Enum
Public Function Add(Optional iIndex As Variant, _
    Optional vKey As Variant, Optional sCaption As String, _
    Optional iStyle As ezButtonStyle, Optional imgImage As StdPicture) As clsButton
    
    ' This function adds a Button to the List
    Dim btnx As New clsButton
    Dim ibtnIndex As Integer
    
       
    With btnx
        .Caption = sCaption
        .Key = vKey
        .Style = iStyle
        Set .Image = imgImage
        .Enabled = True

    End With
    
    ' Add the button to the collection
    ' Determine if we use the index specified or create one
    If IsMissing(iIndex) And IsMissing(vKey) Then
        ' Nothing specified
        colButtons.Add btnx
    ElseIf IsMissing(iIndex) Then
        colButtons.Add btnx, vKey
    ElseIf IsMissing(vKey) Then
        If Val(iIndex) = 1 And mvar_Count = 1 Then
            colButtons.Add btnx
        Else
            colButtons.Add btnx, , Val(iIndex)
        End If
    End If
    
    ' Increment the button count
    mvar_Count = mvar_Count + 1
        
    ' Set the Btnx Object to the Button we just added
    Set Add = btnx
    
    ' Clear the refrence
    Set btnx = Nothing

End Function

Public Sub Clear()
    ' Erases the Collections
    colButtons.Clear
    
    ' Reset the button count
    mvar_Count = 0
End Sub

Public Property Get Count() As Integer
    Count = mvar_Count
End Property

Public Function Item(vKey As Variant) As clsButton
    ' This Function returns the item specified

    On Error Resume Next
    Set Item = colButtons.Item(vKey)

End Function

Public Sub Remove(vKey As Variant)
    ' Removes a button from the collection
    
    'Trap the possible Error
    On Error Resume Next
    
    ' Reset the button Count
    mvar_Count = mvar_Count - 1

    
    colButtons.Remove vKey
    If Err.Number Then
        MsgBox "Remove : this button does not exist"
        Err.Clear
    End If
End Sub

