VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsComboBoxes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' This class duplicates a collection of ComboBoxes
' This collection would pertain to each ComboBox Style button
' in the main collection of the toolbar buttons


' The Counter for the number of entries in the
' ComboBox
Private mvar_Count As Integer

Private colComboBoxes As New Collection

Public Function Add(Optional iIndex As Variant, _
    Optional vKey As Variant, Optional sText As String, _
    Optional bEnabled As Boolean, Optional imgImage As StdPicture) _
    As clsComboBox
    
    Dim cbox As New clsComboBox
    Dim ibtnIndex As Integer
    
       
    With cbox
        .Text = sText
        .Key = vKey
        .Enabled = bEnabled
        Set .Image = imgImage
    End With
    
    ' Add the button to the collection
    ' Determine if we use the index specified or create one
    If IsMissing(iIndex) And IsMissing(vKey) Then
        ' Nothing specified
        colComboBoxes.Add cbox
    ElseIf IsMissing(iIndex) Then
        colComboBoxes.Add cbox, vKey
    ElseIf IsMissing(vKey) Then
        If Val(iIndex) = 1 And mvar_Count = 1 Then
            colComboBoxes.Add cbox
        Else
            colComboBoxes.Add cbox, , Val(iIndex)
        End If
    End If
    
    ' Increment the button count
    mvar_Count = mvar_Count + 1
        
    ' Set the cboX Object to the ComboBox Item we just added
    
    Set Add = cbox
    
    ' Clear the Reference
    Set cbox = Nothing

End Function


Public Sub Clear()
    ' Removes all of the entries in the collection
    
    colComboBoxes.Clear
    
    mvar_Count = 0
End Sub


Public Property Get Count() As Integer
    Count = mvar_Count
End Property

Public Function Item(vKey As Variant) As clsComboBox
    ' This will return a reference to a ComboBOx
    ' object who's Key/INdex is specified in vKey

    On Error Resume Next
    Set Item = colComboBoxes.Item(vKey)
    
End Function


Public Sub Remove(vKey As Variant)
    ' Removes a ComboBox Entry from the collection
    
    'Trap the possible Error
    On Error Resume Next
    
    ' Change the ListCount Count
    mvar_Count = mvar_Count - 1

    
    colComboBoxes.Remove vKey
    If Err.Number Then
        MsgBox "Remove : this ComboBox Entry does not exist"
        Err.Clear
    End If
End Sub


