VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsToolbar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Expose the Buttons Collection
Public Buttons As New clsButtons
' Expose the Button Object
Public Button As New clsButton

' Keep the properties private. They can only be updated
' via get/set/let
Private mvar_Align As Integer
Private mvar_AllowCustomize As Boolean
Private mvar_AutoHide As Boolean
Private mvar_ButtonHeight As Long
Private mvar_ButtonWidth As Long
Private mvar_Caption As String
Private mvar_Container As Object
Private mvar_DragIcon As StdPicture
Private mvar_DragMode As Integer
Private mvar_Enabled As Boolean
Private mvar_Font As StdFont
Private mvar_Height As Long
Private mvar_hWnd As Long
' Private mvar_ImageList
Private mvar_Index As Integer
Private mvar_Left As Long
Private mvar_MouseIcon As StdPicture
Private mvar_MousePointer As Integer
Private mvar_Name As String
Private mvar_Negotiate As Boolean
Private mvar_Parent  As Object
Private mvar_ShowTips As Boolean
Private mvar_TabIndex As Integer
Private mvar_Tag As Variant
Private mvar_Top As Long
Private mvar_Visible As Boolean
Private mvar_WhatsThisHelpID As Long
Private mvar_Width As Long
Private mvar_Wrappable As Boolean

' Methods that are supported
'Customize Method
'Drag Method
'Move Method
'Refresh Method
'RestoreToolbar Method
'SaveToolbar Method
'ShowWhatsThis Method
'ZOrder Method
' Current Version of this control
Private mvar_Version As Double

' Function to Draw Boxes
Private Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Boolean

'-------------------------------------------------------
' Api Constants...
'-------------------------------------------------------

'DrawEdge constants
Private Const BDR_RAISEDOUTER = &H1&
Private Const BDR_RAISEDINNER = &H4&

Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)

Private Const BF_LEFT = &H1&             ' Border flags
Private Const BF_TOP = &H2&
Private Const BF_RIGHT = &H4&
Private Const BF_BOTTOM = &H8&
Private Const BF_RECT = BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM

Private Const BF_SOFT = &H1000&          ' For softer buttons

' Constanst for Line Drawing
Private Const ezRaised = True
Private Const ezSunken = False
Private Const ezHorizontal = True
Private Const ezVertical = False

Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

Private Const iButtonGap = 4    ' The Space between buttons
Private Const lMaskColor = &HC0C0C0 ' The Mask Color of the Images
Public Function ButtonAtLocation(x As Single, y As Single) As Variant
    ' This function will return the button underneath the specified
    ' mouse Coordinates
    
    Dim iTempIdx As Integer
    
    ButtonAtLocation = 0
    For iTempIdx = 1 To Buttons.Count
        If x >= Buttons.Item(iTempIdx).Left And _
            x <= (Buttons.Item(iTempIdx).Left + Buttons.Item(iTempIdx).Width) And _
            y >= Buttons.Item(iTempIdx).Top And _
            y <= (Buttons.Item(iTempIdx).Top + Buttons.Item(iTempIdx).Height) Then
            
            ' We have a Match
            ButtonAtLocation = iTempIdx
            Exit For
        End If
    Next iTempIdx
        
End Function


Public Property Let Caption(vData As String)
    mvar_Caption = vData
    
    ' Change caption if the toolbar is not docked.
    If mvar_Align = vbAlignNone Then
        frmToolbar.Caption = vData
    End If
    
End Property

Public Property Get Caption() As String
    Caption = mvar_Caption
End Property

Public Property Let AutoHide(vData As Boolean)
    mvar_AutoHide = vData
End Property

Public Property Get AutoHide() As Boolean
    AutoHide = mvar_AutoHide
End Property

Public Sub Customize()

End Sub


Public Sub Drag(iAction As Integer)
    ' sAction is the Drag Method

End Sub

Public Sub DrawFrame(iButton As Integer, iButtonState As Integer)
    'This Method will draw a button frame over the button specifed
    ' The type of frame depends on the button state
    
    Dim Toolbar As PictureBox
    
    ' Safety net
    If iButton = 0 Then Exit Sub
    
    Set Toolbar = frmButtonTest.picToolbar
    
    With Buttons.Item(iButton)
        If .Enabled = False Then Exit Sub  ' We don't want to show this
        Select Case iButtonState
            Case 0
                ' Remove the past Box
                ' left
                Toolbar.Line (.Left - 1, .Top - 1)-(.Left - 1, .Top + .Height), vbButtonFace
                ' Top
                Toolbar.Line (.Left - 1, .Top - 1)-(.Left + .Height + 2, .Top - 1), vbButtonFace
                ' Right
                Toolbar.Line (.Left + .Width + 2, .Top - 1)-(.Left + .Width + 2, .Top + .Height), vbButtonFace
                ' Bottom
                Toolbar.Line (.Left - 1, .Top + .Height)-(.Left + .Width + 2, .Top + .Height), vbButtonFace
                
            Case 1
                ' Add a raised Box
                ' left
                Toolbar.Line (.Left - 1, .Top - 1)-(.Left - 1, .Top + .Height), vb3DHighlight
                ' Top
                Toolbar.Line (.Left - 1, .Top - 1)-(.Left + .Height + 2, .Top - 1), vb3DHighlight
                ' Right
                Toolbar.Line (.Left + .Width + 2, .Top - 1)-(.Left + .Width + 2, .Top + .Height), vb3DShadow
                ' Bottom
                Toolbar.Line (.Left - 1, .Top + .Height)-(.Left + .Width + 2, .Top + .Height), vb3DShadow
            Case 2
                ' Add a Sunken Box
                ' left
                Toolbar.Line (.Left - 1, .Top - 1)-(.Left - 1, .Top + .Height), vb3DShadow
                ' Top
                Toolbar.Line (.Left - 1, .Top - 1)-(.Left + .Height + 2, .Top - 1), vb3DShadow
                ' Right
                Toolbar.Line (.Left + .Width + 2, .Top - 1)-(.Left + .Width + 2, .Top + .Height), vb3DHighlight
                ' Bottom
                Toolbar.Line (.Left - 1, .Top + .Height)-(.Left + .Width + 2, .Top + .Height), vb3DHighlight

        End Select
    End With

End Sub

Private Sub DrawLine(lStart As Long, bHorizontal As Boolean, bRaised As Boolean)
    ' Draws an etched line on picToolbar
    
    Select Case bHorizontal
        Case ezVertical  'Horizontal Align- Draw vertical line Left to right
            If bRaised = ezRaised Then
                frmButtonTest.picToolbar.Line (2, lStart)-(frmButtonTest.picToolbar.ScaleWidth - 2, lStart), vb3DHighlight
                frmButtonTest.picToolbar.Line (2, lStart + 1)-(frmButtonTest.picToolbar.ScaleWidth - 2, lStart + 1), vb3DShadow
            Else
                frmButtonTest.picToolbar.Line (2, lStart)-(frmButtonTest.picToolbar.ScaleWidth - 2, lStart), vb3DShadow
                frmButtonTest.picToolbar.Line (2, lStart + 1)-(frmButtonTest.picToolbar.ScaleWidth - 2, lStart + 1), vb3DHighlight
            End If
        Case ezHorizontal ' Vertical Align - Draw Horizontal line Top to Bottom
            If bRaised = ezRaised Then
                frmButtonTest.picToolbar.Line (lStart, 2)-(lStart, frmButtonTest.picToolbar.ScaleHeight - 2), vb3DHighlight
                frmButtonTest.picToolbar.Line (lStart + 1, 2)-(lStart + 1, frmButtonTest.picToolbar.ScaleHeight - 2), vb3DShadow
            Else
                frmButtonTest.picToolbar.Line (lStart, 2)-(lStart, frmButtonTest.picToolbar.ScaleHeight - 2), vb3DShadow
                frmButtonTest.picToolbar.Line (lStart + 1, 2)-(lStart + 1, frmButtonTest.picToolbar.ScaleHeight - 2), vb3DHighlight
            End If
    End Select
    
End Sub

Public Sub Move(lLeft As Long, Optional lTop As Variant, Optional lWidth As Variant, Optional lHeight As Variant)
    mvar_Left = lLeft
    If Not IsMissing(lTop) Then mvar_Top = lTop
    If Not IsMissing(lWidth) Then mvar_Width = lWidth
    If Not IsMissing(lHeight) Then mvar_Height = lHeight
    Refresh
End Sub

Public Sub Refresh()
    ' Redraws the Toolbar
    
    Dim iButtonIndex As Integer
    Dim xStart As Long  ' The Starting position of the Button
    Dim lOther As Long  ' The other cooridinent
    Dim lWidth As Long ' The Image width
    Dim lHeight As Long ' The Image Height
    
    Dim Toolbar As PictureBox
    
    Dim cPaint As New PaintEffects  ' Drawing Rountines
    
    Dim bAlign As Boolean   ' A Flag to tell if we are Vertical or horizontal
    
    Set Toolbar = frmButtonTest.picToolbar ' Easier to work with than the long name
    
    ' Erase the contents of the picture box
    Toolbar.Cls
    
    ' Update the Background of the toolbar
    Toolbar.BackColor = vbButtonFace
    
    ' Determine the Alignment Property and draw the double line
    Select Case Toolbar.Align
        Case vbAlignTop, vbAlignBottom
            bAlign = ezVertical
            DrawLine 2, ezHorizontal, ezRaised
            DrawLine 4, ezHorizontal, ezRaised
        Case vbAlignLeft, vbAlignRight
            bAlign = ezHorizontal
            DrawLine 2, ezVertical, ezRaised
            DrawLine 4, ezVertical, ezRaised
    End Select
    
    Dim edge As RECT    ' Rectangle edge of control
    With edge
        .Left = 0       ' Set rect edges to outer
        .Top = 0        ' - most position in pixels
        .Bottom = Toolbar.ScaleHeight
        .Right = Toolbar.ScaleWidth
    End With
    DrawEdge Toolbar.hdc, edge, BDR_RAISEDOUTER, BF_RECT Or BF_SOFT ' Draw Edge...

    ' If there are no buttons the we don't need to
    ' redraw the buttons
    If Buttons.Count = 0 Then Exit Sub
    
    ' The Default starting position of the buttons
    xStart = 10
    
    ' The Default Top/Left Property
    lOther = 4
    
    ' Start Drawing the buttons
    With Buttons
        For iButtonIndex = 1 To .Count
            Set frmButtonTest.picHolder.Picture = .Item(iButtonIndex).Image
            ' Determine the Hieght And Width for the Buttons in Pixels
            lWidth = frmButtonTest.picHolder.ScaleX(.Item(iButtonIndex).Image.Width, vbHimetric, vbTwips) _
                / Screen.TwipsPerPixelX
            lHeight = frmButtonTest.picHolder.ScaleY(.Item(iButtonIndex).Image.Height, vbHimetric, vbTwips) _
                / Screen.TwipsPerPixelY
            .Item(iButtonIndex).Width = lWidth
            .Item(iButtonIndex).Height = lHeight
            Select Case bAlign
                ' Top/Bottom Alignment
                Case ezVertical
                    .Item(iButtonIndex).Top = lOther
                    .Item(iButtonIndex).Left = xStart
                    Select Case .Item(iButtonIndex).Style
                        Case 0  ' Default
                            If .Item(iButtonIndex).Enabled Then
                                cPaint.PaintTransparentStdPic Toolbar.hdc, xStart + 1, lOther, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            Else
                                cPaint.PaintDisabledStdPic Toolbar.hdc, xStart + 1, lOther, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            End If
                            xStart = xStart + lWidth + 2
                            
                        Case 1  ' Check Box
                            If .Item(iButtonIndex).Enabled Then
                                cPaint.PaintTransparentStdPic Toolbar.hdc, xStart + 1, lOther, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            Else
                                cPaint.PaintDisabledStdPic Toolbar.hdc, xStart + 1, lOther, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            End If
                            xStart = xStart + lWidth + 2
                        Case 2  ' Button Group
                            If .Item(iButtonIndex).Enabled Then
                                cPaint.PaintTransparentStdPic Toolbar.hdc, xStart + 1, lOther, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            Else
                                cPaint.PaintDisabledStdPic Toolbar.hdc, xStart + 1, lOther, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            End If
                            xStart = xStart + lWidth + 2
                        Case 3  ' Separator
                            DrawLine xStart + 2, ezHorizontal, ezSunken
                            xStart = xStart + 6
                        Case 4  ' PlaceHolder
                        
                        Case 5  ' ComboBox
                            If .Item(iButtonIndex).Enabled Then
                                cPaint.PaintTransparentStdPic Toolbar.hdc, xStart + 1, lOther, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            Else
                                cPaint.PaintDisabledStdPic Toolbar.hdc, xStart + 1, lOther, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            End If
                            xStart = xStart + lWidth + 2
                    End Select
                
                Case ezHorizontal
                    'Right/Left Alignment
                    .Item(iButtonIndex).Top = xStart
                    .Item(iButtonIndex).Left = lOther
                    Select Case .Item(iButtonIndex).Style
                        Case 0  ' Default
                           If .Item(iButtonIndex).Enabled Then
                                cPaint.PaintTransparentStdPic Toolbar.hdc, lOther, xStart + 1, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            Else
                                cPaint.PaintDisabledStdPic Toolbar.hdc, xStart + 1, lOther, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            End If
                            xStart = xStart + lHeight + 2
                        Case 1  ' Check Box
                            If .Item(iButtonIndex).Enabled Then
                                cPaint.PaintTransparentStdPic Toolbar.hdc, lOther, xStart + 1, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            Else
                                cPaint.PaintDisabledStdPic Toolbar.hdc, lOther, xStart + 1, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            End If
                            xStart = xStart + lHeight + 2
                        Case 2  ' Button Group
                            If .Item(iButtonIndex).Enabled Then
                                cPaint.PaintTransparentStdPic Toolbar.hdc, lOther, xStart + 1, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            Else
                                cPaint.PaintDisabledStdPic Toolbar.hdc, lOther, xStart + 1, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            End If
                            xStart = xStart + lHeight + 2
                        Case 3  ' Separator
                            DrawLine xStart + 2, ezVertical, ezSunken
                            xStart = xStart + 6
                        Case 4  ' PlaceHolder
                        
                        Case 5  ' ComboBox
                            If .Item(iButtonIndex).Enabled Then
                                cPaint.PaintTransparentStdPic Toolbar.hdc, lOther, xStart + 1, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            Else
                                cPaint.PaintDisabledStdPic Toolbar.hdc, xStart + 1, lOther, lWidth, _
                                    lHeight, .Item(iButtonIndex).Image, 0, 0, lMaskColor
                            End If
                            xStart = xStart + lHeight + 2
                    End Select
                End Select
        Next iButtonIndex
    End With
    
End Sub

Public Sub RestoreToolbar(Key As Integer, subkey As String, Value As String)

End Sub
Public Sub SaveToolbar(Key As Integer, subkey As String, Value As String)

End Sub
Public Sub ShowWhatsThis()

End Sub


Public Property Let Align(vData As Integer)
    mvar_Align = vData
    
    frmButtonTest.picToolbar.Align = vData
    Select Case vData
        Case vbAlignRight, vbAlignLeft
            frmButtonTest.picToolbar.Width = 360
        Case vbAlignTop, vbAlignBottom
            frmButtonTest.picToolbar.Height = 360
        Case vbAlignNone
            Set mvar_Container = frmToolbar
    End Select
    
    Refresh
End Property
Public Property Get Align() As Integer
    Align = mvar_Align
End Property

Public Property Let AllowCustomize(vData As Boolean)
    mvar_AllowCustomize = vData
End Property

Public Property Get AllowCustomize() As Boolean
    AllowCustomize = mvar_AllowCustomize
End Property
Public Property Let ButtonHeight(vData As Long)
    mvar_ButtonHeight = vData
End Property

Public Property Get ButtonHeight() As Long
    ButtonHeight = mvar_ButtonHeight
End Property
Public Property Let ButtonWidth(vData As Long)
    mvar_ButtonWidth = vData
End Property
Public Property Get ButtonWidth() As Long
    ButtonWidth = mvar_ButtonWidth
End Property
Public Property Set Container(vData As Object)
    Set mvar_Container = vData
    
    If mvar_Container.Name = "frmToolbar" Then
        ' Update the caption if were ar on the toolbar form
        frmToolbar.Caption = mvar_Caption
    End If
    
End Property
Public Property Get Container() As Object
    Set Container = mvar_Container
End Property



Public Property Set DragIcon(vData As StdPicture)
    Set mvar_DragIcon = vData
End Property

Public Property Get DragIcon() As StdPicture
    Set DragIcon = mvar_DragIcon
End Property




Public Property Let DragMode(vData As Long)
    mvar_DragMode = vData
End Property

Public Property Get DragMode() As Long
    DragMode = mvar_DragMode
End Property

Public Property Let Enabled(vData As Boolean)
    mvar_Enabled = vData
End Property

Public Property Get Enabled() As Boolean
    Enabled = mvar_Enabled
End Property

Public Property Set Font(vData As StdFont)
    Set mvar_Font = vData
End Property

Public Property Get Font() As StdFont
    Set Font = mvar_Font
End Property

Public Property Let Height(vData As Long)
    mvar_Height = vData
    
    If mvar_Align <> vbAlignNone Then Exit Property
    
    frmButtonTest.picToolbar.Height = vData
End Property

Public Property Get Height() As Long
    Height = mvar_Height
End Property

Public Property Get hwnd() As Long
    hwnd = mvar_hWnd
End Property

Public Property Let Index(vData As Integer)
    mvar_Index = vData
End Property
Public Property Get Index() As Integer
    Index = mvar_Index
End Property


Public Property Let Left(vData As Long)
    mvar_Left = vData
    If mvar_Align <> vbAlignNone Then Exit Property
    
    frmButtonTest.picToolbar.Left = vData
End Property

Public Property Get Left() As Long
    Left = mvar_Left
End Property

Public Property Set MouseIcon(vData As StdPicture)
    Set mvar_MouseIcon = vData
End Property

Public Property Let MousePointer(vData As Integer)
    mvar_MousePointer = vData
End Property
Public Property Get MouseIcon() As StdPicture
    Set MouseIcon = mvar_MouseIcon
End Property

Public Property Get MousePointer() As Integer
    MousePointer = mvar_MousePointer
End Property

Public Property Get Name() As String
    Name = mvar_Name
End Property

Public Property Let Negotiate(vData As Boolean)
    mvar_Negotiate = vData
End Property

Public Property Get Negotiate() As Boolean
    Negotiate = mvar_Negotiate
End Property

Public Property Set Parent(vData As Object)
    Set mvar_Parent = vData
End Property
Public Property Get Parent() As Object
    Set Parent = mvar_Parent
End Property

Public Property Let ShowTips(vData As Boolean)
    mvar_ShowTips = vData
End Property

Public Property Get ShowTips() As Boolean
    ShowTips = mvar_ShowTips
End Property

Public Property Let TabIndex(vData As Integer)
    mvar_TabIndex = vData
End Property

Public Property Get TabIndex() As Integer
    TabIndex = mvar_TabIndex
End Property

Public Property Let Tag(vData As Variant)
    mvar_Tag = vData
End Property

Public Property Get Tag() As Variant
    Tag = mvar_Tag
End Property

Public Property Get Top() As Long
    Top = mvar_Top
End Property

Public Property Let Top(vData As Long)
    mvar_Top = vData
    If mvar_Align <> vbAlignNone Then Exit Property
    
    frmButtonTest.picToolbar.Top = vData
End Property

Public Property Get Version() As Double
    Version = mvar_Version
End Property

Public Property Let Visible(vData As Boolean)
    mvar_Visible = True
End Property

Public Property Get Visible() As Boolean
    Visible = mvar_Visible
End Property

Public Property Let WhatsThisHelpId(vData As Long)
    mvar_WhatsThisHelpID = vData
End Property

Public Property Get WhatsThisHelpId() As Long
    WhatsThisHelpId = mvar_WhatsThisHelpID
End Property

Public Property Let Width(vData As Long)
    mvar_Width = vData
    If mvar_Align <> vbAlignNone Then Exit Property
    
    frmButtonTest.picToolbar.Width = vData
End Property

Public Property Get Width() As Long
    Width = mvar_Width
End Property

Public Property Let Wrappable(vData As Boolean)
    mvar_Wrappable = vData
End Property

Public Property Get Wrappable() As Boolean
    Wrappable = mvar_Wrappable
End Property

Private Sub Zorder(iIndex As Integer)

End Sub

Private Sub Class_Initialize()
    mvar_Version = 0.01
End Sub


